<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "directory_setting".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DirectorySetting".
 *
 * Columns in table "directory_setting" available as properties of the model,
 * followed by relations of table "directory_setting" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $partner_site_id
 * @property integer $hidden
 * @property integer $draft
 * @property string $key_code
 * @property string $name
 * @property string $directory_type
 * @property string $environment
 * @property string $url
 * @property string $options
 * @property integer $life_science
 * @property integer $cors_enabled
 * @property string $cors_domain
 * @property string $config_back
 * @property string $config_front
 * @property integer $is_template
 * @property integer $parent_template_id
 * @property string $quick_config
 * @property integer $is_production
 * @property string $version
 * @property integer $enabled
 * @property integer $editable
 * @property integer $updated_by
 * @property string $date_updated
 *
 * @property DirectoryPartnerLayout[] $directoryPartnerLayouts
 * @property Account $account
 * @property PartnerSite $partnerSite
 * @property Account $updatedBy
 * @property ProviderPracticeDirectory[] $providerPracticeDirectories
 * @property ProviderPracticeDirectoryExcluded[] $providerPracticeDirectoryExcludeds
 * @property ProviderPracticeDirectoryRemoved[] $providerPracticeDirectoryRemoveds
 */
abstract class BaseDirectorySetting extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'directory_setting';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DirectorySetting|DirectorySettings', $n);
    }

    public static function representingColumn()
    {
        return 'key_code';
    }

    public function rules()
    {
        return array(
            array('key_code, name, directory_type, options, version', 'required'),
            array('account_id, partner_site_id, hidden, draft, life_science, cors_enabled, is_template, parent_template_id, is_production, enabled, editable, updated_by', 'numerical', 'integerOnly'=>true),
            array('key_code', 'length', 'max'=>32),
            array('name', 'length', 'max'=>150),
            array('directory_type', 'length', 'max'=>6),
            array('environment, version', 'length', 'max'=>50),
            array('url', 'length', 'max'=>255),
            array('quick_config', 'length', 'max'=>1),
            array('cors_domain, config_back, config_front, date_updated', 'safe'),
            array('account_id, partner_site_id, hidden, draft, environment, url, life_science, cors_enabled, cors_domain, config_back, config_front, is_template, parent_template_id, quick_config, is_production, enabled, editable, updated_by, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_id, partner_site_id, hidden, draft, key_code, name, directory_type, environment, url, options, life_science, cors_enabled, cors_domain, config_back, config_front, is_template, parent_template_id, quick_config, is_production, version, enabled, editable, updated_by, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'directoryPartnerLayouts' => array(self::HAS_MANY, 'DirectoryPartnerLayout', 'directory_setting_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'updatedBy' => array(self::BELONGS_TO, 'Account', 'updated_by'),
            'providerPracticeDirectories' => array(self::HAS_MANY, 'ProviderPracticeDirectory', 'directory_setting_id'),
            'providerPracticeDirectoryExcludeds' => array(self::HAS_MANY, 'ProviderPracticeDirectoryExcluded', 'directory_setting_id'),
            'providerPracticeDirectoryRemoveds' => array(self::HAS_MANY, 'ProviderPracticeDirectoryRemoved', 'directory_setting_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'partner_site_id' => null,
            'hidden' => Yii::t('app', 'Hidden'),
            'draft' => Yii::t('app', 'Draft'),
            'key_code' => Yii::t('app', 'Key Code'),
            'name' => Yii::t('app', 'Name'),
            'directory_type' => Yii::t('app', 'Directory Type'),
            'environment' => Yii::t('app', 'Environment'),
            'url' => Yii::t('app', 'Url'),
            'options' => Yii::t('app', 'Options'),
            'life_science' => Yii::t('app', 'Life Science'),
            'cors_enabled' => Yii::t('app', 'Cors Enabled'),
            'cors_domain' => Yii::t('app', 'Cors Domain'),
            'config_back' => Yii::t('app', 'Config Back'),
            'config_front' => Yii::t('app', 'Config Front'),
            'is_template' => Yii::t('app', 'Is Template'),
            'parent_template_id' => Yii::t('app', 'Parent Template'),
            'quick_config' => Yii::t('app', 'Quick Config'),
            'is_production' => Yii::t('app', 'Is Production'),
            'version' => Yii::t('app', 'Version'),
            'enabled' => Yii::t('app', 'Enabled'),
            'editable' => Yii::t('app', 'Editable'),
            'updated_by' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'directoryPartnerLayouts' => null,
            'account' => null,
            'partnerSite' => null,
            'updatedBy' => null,
            'providerPracticeDirectories' => null,
            'providerPracticeDirectoryExcludeds' => null,
            'providerPracticeDirectoryRemoveds' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('hidden', $this->hidden);
        $criteria->compare('draft', $this->draft);
        $criteria->compare('key_code', $this->key_code, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('directory_type', $this->directory_type, true);
        $criteria->compare('environment', $this->environment, true);
        $criteria->compare('url', $this->url, true);
        $criteria->compare('options', $this->options, true);
        $criteria->compare('life_science', $this->life_science);
        $criteria->compare('cors_enabled', $this->cors_enabled);
        $criteria->compare('cors_domain', $this->cors_domain, true);
        $criteria->compare('config_back', $this->config_back, true);
        $criteria->compare('config_front', $this->config_front, true);
        $criteria->compare('is_template', $this->is_template);
        $criteria->compare('parent_template_id', $this->parent_template_id);
        $criteria->compare('quick_config', $this->quick_config, true);
        $criteria->compare('is_production', $this->is_production);
        $criteria->compare('version', $this->version, true);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('editable', $this->editable);
        $criteria->compare('updated_by', $this->updated_by);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}